<?php
// +-----------------------------------------------------------------------+
// | Mod Name : Blob                                                       |
// | Mod Version : 1.1                                                     |
// | Mod Version author : FlipFlip <flipflip@free.fr>                      |
// | Mod description :                                                     |
// | Ce module permet la copie de la vignette dans un champ blob           |
// | pour pouvoir la rcuprer par CrystalReport                           |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

class Blob {
  var $plugin_name, $plugin_path, $plugin_url;

  function Blob($plugin_name, $plugin_path, $plugin_url) {
    // Args
    $this->plugin_name = $plugin_name;
    $this->plugin_path = $plugin_path;
    $this->plugin_url = $plugin_url;
    // handler
    $this->initialize_event_handler($plugin_name, $plugin_path, $plugin_url);
  }
  
  function initialize_event_handler() {
  	$this->load_lang(); // Chargement des langues
  	
    add_event_handler('add_images', array(&$this, 'AjoutBlob'));
    add_event_handler('delete_elements', array(&$this, 'DeleteBlob'));

    if (is_admin()) {
      // ---- Administration
      add_event_handler('get_admin_plugin_menu_links', array(&$this, 'plugin_admin_menu')); // Menu d'administration
    } 
  }  

  // Affichage du lien dans la barre
  // menu administrateur
  function plugin_admin_menu($menu) {
    array_push($menu,
      array(
        'NAME' => 'Blob',
        'URL' => get_admin_plugin_menu_link($this->plugin_path.'admin/BlobAdmin.php')
      )
    );
    return $menu;
  }  

  // Chargement des fichiers langues
  function load_lang() {
    global $lang;
    include(get_language_filepath('plugin.lang.php', $this->plugin_path) );
  }
  
  function AjoutBlob($inserts) {
    global $conf, $prefixeTable;
    
    foreach($inserts as $cle => $file) {
      $dirname = dirname($file['path']);

      $name = explode('.', $file['file']);
      $filename = $name[0];
      
      $handle = fopen($dirname.'/thumbnail/'.$conf['prefix_thumbnail'].$filename.'.'.$file['tn_ext'], 'rb');
      $content = addslashes(fread($handle, filesize($dirname.'/thumbnail/'.$conf['prefix_thumbnail'].$filename.'.'.$file['tn_ext'])));
      fclose ($handle);
                	
      $query = '
        INSERT INTO '.$prefixeTable.'image_blob(id, name, contents) 
        VALUES("'.$file['id'].'", "'.$name[0].'", "'.$content.'")
      ;';
      
      pwg_query($query);    	
    }
  }
  
  function DeleteBlob($ids) {
  	global $prefixeTable;
  	$query = '
  	  DELETE FROM '.$prefixeTable.'image_blob
  	  WHERE id IN(
  	    '.wordwrap(implode(', ', $ids), 80, "\n").')
      ;';
  	
  	pwg_query($query);
  }
}
?>
